# -*- coding: utf-8 -*-
"""
Created on Thu Mar  4 11:49:17 2021

@author: Dohmen
"""

import os
import pprint
import numpy as np
from pathlib import Path
from collections import Counter

pp = pprint.PrettyPrinter()


def extract_numbers(string):
    """
    Extract numbers from a string.

    Parameters
    ----------
    string : str
        String containing multiple numbers for extraction.

    Returns
    -------
    numbers : lst
        List of floats numbers found in string.
    """
    numbers = []
    current = ''
    for char in string.lower() + '!':
        if (char.isdigit() or
            (char == 'e' and ('e' not in current) and
             (current not in ['', '.', '-', '-.'])) or
            (char == '.' and ('e' not in current) and ('.' not in current)) or
            (char == '+' and current.endswith('e')) or
                (char == '-' and ((current == '') or current.endswith('e')))):
            current += char
        else:
            if current not in ['', '.', '-', '-.']:
                if current.endswith('e'):
                    current = current[:-1]
                elif current.endswith('e-') or current.endswith('e+'):
                    current = current[:-2]
                numbers.append(current)
            if char == '.' or char == '-':
                current = char
            else:
                current = ''

    # Convert from strings to actual python numbers.
    numbers = [float(t) if ('.' in t or 'e' in t) else int(t) for t in numbers]

    return numbers


def read_lin_file(file):
    """
    Read the .lin file generated by pickett

    Parameters
    ----------
    file : str
        String of complete filepath of the file to read.

    Returns
    -------
    transitions : 2D array
        numpy array withn information of in lin file formated as floats.
    """
    with open(file) as linFile:
        transitions = []
        for ind, line in enumerate(linFile, 1):
            if len([float(i) for i in extract_numbers(line)]) > 0:
                transitions.append([float(i) for i in extract_numbers(line)])
    transitions = np.array(transitions, dtype=object)
    return transitions


def read_multiple_linfiles(dir_path):
    """
    Read all .lin files found in directory and its subdirectories.

    Parameters
    ----------
    dir_path : str
        Complete path to .lin files in a single directory.

    Returns
    -------
    lin_dict : dict
        Dictionary which contains python arrays of the information in the .lin
        files. The keys are the file names.
    """
    files = []
    for path in Path(dir_path).rglob('*.lin'):
        files.append(path.resolve())
    lin_dict = {}
    for file in files:
        trans = read_lin_file(file)
        if len(trans) > 0:
            filename = os.path.split(file)[1]
            filename = os.path.splitext(filename)[0]
            lin_dict[filename] = trans
    return lin_dict


def search_for_duplicates(lin_dict):
    """
    Search for duplicates in the line assignment.

    Parameters
    ----------
    lin_dict : dict
        Dictionary which contains python arrays of the information in the .lin
        files. The keys are the file names.

    Returns
    -------
    doubles : 2D array
        Array like which lists frequencies assigned twice in .lin files in the
        same directory. Columns one and two contain the names of the .lin files
        and column three contains the frequency.
        This information is also printed by the function.

    """
    keys = list(lin_dict.keys())
    doubles = []
    for key1ind, key1 in enumerate(keys):
        double_trans = [item for item, count in Counter(
            lin_dict[keys[key1ind]][:, -3]).items() if count > 1]
        if len(double_trans) > 0:
            for trans in double_trans:
                doubles.append([keys[key1ind],  keys[key1ind], trans])
        for key2ind in np.arange(key1ind + 1, len(keys)):
            double_trans = np.intersect1d(lin_dict[keys[key1ind]][:, -3],
                                          lin_dict[keys[key2ind]][:, -3])
            if len(double_trans) > 0:
                for trans in double_trans:
                    doubles.append([keys[key1ind],  keys[key2ind], trans])

    doubles = sorted(doubles, key=lambda x: x[2])
    for i in np.arange(len(doubles)):
        print('Line at {2} MHz doubly assigned in file {0} and {1}'.format(
            *doubles[i]))
    return doubles


def same_qantum_numbers(lin_dict, key1, key2):
    """
    Search for quantum numbers are assigned in two different .lin files.

    Search for transitions with the same quantum numbers in both files to
    compare them for population ratios and alike.

    Parameters
    ----------
    lin_dict : dict
        Dictionary which contains python arrays of the information in the .lin
        files. The keys are the file names.
    key1 : str
        Name of first .lin file which is contained in the lin_dict.
    key2 : str
        Name of second .lin file which is contained in the lin_dict.

    Returns
    -------
    duplicate_qn : lst
        List wich contains transitions with quantum numbers that appear in both
        .lin files in string format. This information is also printed by the
        function.
    """
    keys = list(lin_dict.keys())
    if (key1 and key2) not in keys:
        print('keys are not available in lin dict')
    str1 = np.array(["  ".join(item)
                     for item in lin_dict[key1][:, :-3].astype(int).astype(str)
                     ])
    str2 = np.array(["  ".join(item)
                     for item in lin_dict[key2][:, :-3].astype(int).astype(str)
                     ])
    duplicate_qn = np.intersect1d(str1, str2)
    for ind, qn in enumerate(duplicate_qn):
        print('Quantum numbers {} assigned in file {}.lin and {}.lin'.format(
            qn, key1, key2))
    return duplicate_qn
